/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 01 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

int *merge3_ver1 (int *a, int *b, int *c, int na, int nb, int nc) {
  int tot = na+nb+nc;
  int *d, i, ia=0, ib=0, ic=0;

  // Allocate result array
  d = malloc (tot * sizeof(int));
  if (d==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  // Iterate through all input (na+nb+nc) values
  for (i=0; i<tot; i++) {
    if (ia<na && ib<nb && ic<nc) {
      if (a[ia] < b[ib])
        d[i] = a[ia] < c[ic] ? a[ia++] : c[ic++];
      else {
        d[i] = b[ib] < c[ic] ? b[ib++] : c[ic++];
      }
    } else if(ia < na && ib < nb){
      d[i] = a[ia] < b[ib] ? a[ia++] : b[ib++];
    } else if(ia < na && ic < nc){
      d[i] = a[ia] < c[ic] ? a[ia++] : c[ic++];
    } else if(ib < nb && ic < nc){
      d[i] = b[ib] < c[ic] ? b[ib++] : c[ic++];
    } else if(ia < na ){
      d[i] =  a[ia++];
    } else if(ib < nb ){
      d[i] =  b[ib++];
    } else if(ic < nc ){
      d[i] =  c[ic++];
    }
  }

  return d;
}

int *merge3_ver2 (int *a1, int *a2, int *a3, int n1, int n2, int n3) {
  int *d;
  int *m[3], len[3];
  int i, imin, j, n;

  m[0]= a1;
  m[1]= a2;
  m[2]= a3;
  len[0] = n1;
  len[1] = n2;
  len[2] = n3;

  n = n1+n2+n3;
  d = (int *) malloc (n * sizeof(int));
  if (d==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit (EXIT_FAILURE);
  }

  for (i=0; i<n; i++) {
    // ... When a minimum candidate hasn't been found yet
    imin= -1;
    // minimum search
    for (j=0; j<3; j++) {
      if (len[j] != 0 && (imin == -1 || *m[imin] > *m[j])) {
        imin= j;
      }
    }
    d[i] = *m[imin];
    m[imin]++;
    len[imin]--;
  }

  return d;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
