/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 01 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include <float.h>

static void evaluate (float *, float [], float *, float *, float *, int);

void permute(
  int taken[], float sol[], float best_sol[], float *best_diff,
  float mov[], float *min, float *max, int level, int tot_level
) {
  int i;

  if (level == tot_level) {
    evaluate (sol, best_sol, best_diff, min, max, tot_level);
  }

  for (i=0; i<tot_level; i++) {
    if (taken[i]==1) {
      continue;
    }
    taken[i] = 1;
    sol[level] = mov[i];
    permute (taken, sol, best_sol, best_diff, mov, min, max, level+1, tot_level);
    taken[i] = 0;
  }

  return;
}

static void evaluate (
  float *sol, float best_sol[], float *best_diff,
  float *min, float *max, int tot_level
) {
  int i;
  float tot = 0, cmin = FLT_MAX, cmax = FLT_MIN;

  for (i=0; i<tot_level; i++) {
    tot += sol[i];
    cmin = tot < cmin ? tot : cmin;
    cmax = tot > cmax ? tot : cmax;
  }

  if ((cmax - cmin) < *best_diff) {
    *best_diff = cmax-cmin;
    for(i=0; i<tot_level; i++) {
      best_sol[i] = sol[i];
    }
    *min = cmin;
    *max = cmax;
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
