/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 03 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static node_t *node_new (float, int, node_t *);

void mat_insert (matr_t *mat, int r, int c, float value) {
  node_t *n, *prev;
  int overwrite = 0;

  if (r >= mat->nr || c >= mat->nc) {
    return;
  }
  if (mat->rows[r].ne == 0) {
    // First element ever
    mat->rows[r].next = node_new(value, c, NULL);
  } else {
    // Sorted insert
    prev = NULL;
    n = mat->rows[r].next;
    while (n != NULL && n->col < c) {
      prev = n;
      n = n->next;
    }

    if (n != NULL) {
      // In the middle of the list...
      if (n->col == c) {
        // Overwrite
        n->f = value;
        overwrite = 1;
      } else {
        // New node in the middle...
        if (prev != NULL)
          prev->next = node_new(value, c, n);
        else {
          mat->rows[r].next = node_new(value, c, n);
        }
      }
    } else {
      // Bottom of the list
      prev->next = node_new(value, c, NULL);
    }

  }
  if (!overwrite) {
    mat->rows[r].ne++;
  }

  return;
}

static node_t *node_new (float value, int col, node_t *next) {
  node_t *n = malloc(sizeof(node_t));

  if (n == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
     exit(EXIT_FAILURE);
  }
  n->col = col;
  n->f = value;
  n->next = next;

  return n;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
