/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 09 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* Version 1 */
void duplicate_erase_ver1 (char *str) {
  int i, j, k;

  for (i=0; str[i]!='\0'; i++) {
    for (j=i+1; str[j]!='\0'; j++) {
      if (str[i]==str[j]) {
        for (k=j; str[k]!='\0'; k++) {
          str[k] = str[k+1];
        }
        j--;
      }
    }
  }
}

/* Version 2 */
void duplicate_erase_ver2 (char *str) {
  int l, i, j;
  int *v;

  l = strlen (str);
  v = malloc (l * sizeof (int));
  if (v==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }  
  for (i=0; i<l; i++) {
    v[i] = 0;
  }
  for (i=0; i<l-1; i++) {
    if (v[i]==0) {
      for (j=i+1; j<l; j++) {
        if (str[i]==str[j]) {
          v[j] = 1;
        }
      }
    }
  }
  for (i=j=0; i<l; i++) {
    if (v[i]==0) {
      str[j] = str[i];
      j++;
    }
  }
  str[j] = '\0';

  free (v);
  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
