/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 09 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX 100
#define N     3

void file_read (FILE *, char ***, int *);
void play (FILE *, char **, int, char *, int);

int main (int argc, char *argv[]) {
  FILE *fpR, *fpW;
  int i, n;
  char **mat, *vet;
  
  fpR = fopen (argv[1], "r");
  fpW = fopen (argv[2], "w");
  if (fpR==NULL || fpW==NULL) {
    fprintf (stderr, "File open error.\n");
    exit(EXIT_FAILURE);
  }
  
  file_read (fpR, &mat, &n);
  
  vet = (char *) malloc (n * sizeof (char));
  if (vet == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  play (fpW, mat, n, vet, 0);
  
  for (i=0; i<n; i++) {
    free (mat[i]);
  }
  free (mat);
  free (vet);

  fclose (fpR);
  fclose (fpW);

  return (0);
}

/*
 * Read input file into matrix mat
 */
void file_read (FILE *fp, char ***mat, int *n) {
  int i, j;
  char **tmp, s[MAX];
  
  if (fscanf (fp, "%d", n) == EOF) {
    fprintf (stderr, "File error.\n");
    return;
  }

  tmp = (char **) malloc (*n * sizeof (char *));
  if (tmp == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    return;
  }

  i = 0;
  while (fscanf (fp, "%s", s) != EOF && i<(*n)) {
    tmp[i] = (char *) malloc ((strlen(s)+1) * sizeof (char *));
    if (tmp[i] == NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      return;
    }
    // For each row: First char = strlen
    tmp[i][0] = strlen (s);
    // For each row: Next chars = string chars
    for (j=0; j<strlen (s); j++) {
      tmp[i][j+1] = s[j];
    }
    i++;
  }

  // Copy local pointer to parameter 
  *mat = tmp;

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
