/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 13 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

void tree_dup (struct node *root) {
  node_t *tmp;

  // Check termination and (eventually) recur
  if (root == NULL){
    return;
  }
  tree_dup (root->left);
  tree_dup (root->right);

  // Once back, duplicate the node
  tmp = (node_t *) malloc (1 * sizeof (node_t));
  if (tmp == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  tmp->key = root->key;
  // Link from new node to children
  tmp->left = root->left;
  tmp->right = NULL;
  // Link from parent to new node
  root->left = tmp;

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
