/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 13 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl3.h"

static void seekH (product_t *, char *, char *);

/*
 * Vertical recursion:
 * pr = main list pointer; prn = producer name; ptn = product name
 */
void seekV (producer_t *pr, char *prn, char *ptn) {
  if (pr == NULL) {
    return;
  }
  if (strcmp (pr->name, prn) > 0) {
    return;
  }
  if (strcmp (pr->name, prn) < 0) {
    seekV (pr->next, prn, ptn);
    return;
  }
  if (strcmp (pr->name, prn) == 0) {
    seekH (pr->products, prn, ptn);
    return;
  }
  fprintf (stderr, "seekV error!\n");
  exit (EXIT_FAILURE);
}

/*
 * Horizontal recursion:
 * pt = secondary list pointer; prn = producer name; ptn = product name
 */
static void seekH (product_t *pt, char *prn, char *ptn) {
  if (pt == NULL) {
    return;
  }
  if (strcmp (pt->name, ptn) > 0) {
    return;
  }
  if (strcmp (pt->name, ptn) < 0) {
    seekH(pt->next, prn, ptn);
    return;
  }
  if (strcmp (pt->name, ptn) == 0) {
    fprintf (stdout, "Producer=%s Product=%s Price=%d\n", prn, ptn, pt->price);
    return;
  }
  fprintf (stderr, "seekH error.\n");
  return;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
