/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 19 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define SIZE  10

/* Version 1 */
int area_ver1 (FILE *fp) {
  int mat[SIZE][SIZE], count;
  int x1, x2, y1, y2, r, c;

  for (r=0; r<SIZE; r++) {
    for (c=0; c<SIZE; c++) {
      mat[r][c] = 0;
    }
  }

  /* Read file */
  while (fscanf (fp, "%d%d%d%d", &x1, &y1, &x2, &y2) != EOF) {
    if (x1<0 || x1>SIZE || y1<0 || y1>SIZE ||
        x2<0 || x2>SIZE || y2<0 || y2>SIZE) {
      fprintf (stderr,
        "Skipping rectangle out of bound (%d,%d,%d,%d).\n",
        x1, y1, x2, y2);
      continue;
    }
    /* Mark cells */
    for (r=x1; r<x2; r++) {
      for (c=y1; c<y2; c++) {
        mat[r][c] = 1;
      }
    }
  }

  /* Count marked cells */
  count = 0;
  for (r=0; r<SIZE; r++) {
    for (c=0; c<SIZE; c++) {
      if (mat[r][c] == 1) {
        count++;
      }
    }
  }
 
  return (count);
}

/* Version 2 */
int area_ver2 (FILE *fp) {
  /* Define and initialize mat */
  int mat[SIZE][SIZE] = {{0}};
  int x1, x2, y1, y2, r, c, tot = 0;

  /* Read file */
  while(fscanf(fp,"%d %d %d %d", &x1, &y1, &x2, &y2) == 4) {
    if (x1<0 || x1>SIZE || y1<0 || y1>SIZE ||
        x2<0 || x2>SIZE || y2<0 || y2>SIZE) {
      fprintf (stderr,
        "Skipping rectangle out of bound (%d,%d,%d,%d).\n",
        x1, y1, x2, y2);
      continue;
    }

    /* Count and mark cells */
    for (r=x1; r<x2; r++) {
      for (c=y1; c<y2; c++) {
        if (mat[r][c] == 0) {
          tot++;
          mat[r][c] = 1;
        }
      }
    }
  }

  return tot;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
