/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 19 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static list_t *enqueue (list_t *, list_t *);

void split (
  list_t **head, int threshold, list_t **head1, list_t **head2
) {
  list_t *p, *tmp, *pTail1, *pTail2;

  pTail1 = NULL;
  pTail2 = NULL;
  p = *head;
  while (p!=NULL) {
    // Pop
    tmp = p;
    p = p->next;    
    // Enqueue
    if (tmp->val < threshold) {
      pTail1 = enqueue (pTail1, tmp);
    } else {
      pTail2 = enqueue (pTail2, tmp);
    }
  }

  *head = NULL;
  
  // From circular to linear lists
  if (pTail1->next!=NULL) {
    *head1 = pTail1->next;
    pTail1->next = NULL;
  }
  if (pTail2->next!=NULL) {
    *head2 = pTail2->next;
    pTail2->next = NULL;
  }

  return;
}

// Circular List Implementation
list_t *enqueue (list_t *pTail, list_t *p) {
  if (pTail==NULL) {
    pTail = p;
    pTail->next = p;
 } else {
    p->next = pTail->next;
    pTail->next = p;
    pTail = p;
  }

  return (pTail);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
