/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 20 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "symbolTable.h"

struct st_s {
  char **name;
  int *color;
  int maxN;
  int N;
};

st_t st_init (int maxN) {
  st_t tab;

  tab = malloc (1 * +sizeof (struct st_s));
  if (tab == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  tab->name = malloc (maxN * sizeof (char *));
  tab->color = malloc (maxN * sizeof (int));
  if (tab->name==NULL || tab->color==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  tab->maxN = maxN;
  tab->N = 0;

  return tab;
}

int st_search (st_t tab, char *key) {
  int i;

  // Linear search: May be improved with binary search or other techniques
  for (i=0; i<tab->N; i++) {
    if (strcmp(tab->name[i], key) == 0) {
      return i;
    }
  }
  
  return -1;
}

int st_get_num (st_t tab) {
  return tab->N;
}

int st_insert (st_t tab, char *name, int color) {
  int id = tab->N;
  if (tab->N >= tab->maxN) {
    tab->name = realloc (tab->name, (2*tab->maxN) * sizeof (char *));
    tab->color = realloc (tab->color, (2*tab->maxN) * sizeof (int));
    if (tab->name==NULL || tab->color==NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
    tab->maxN = 2*tab->maxN;
  }
  tab->name[id] = strdup (name);
  tab->color[id] = color;
  tab->N++;
  
  return id;
}

int  st_get_color (st_t t, int i) {
  return (t->color[i]);
}

char *st_get_name (st_t t, int i) {
  return (t->name[i]);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
