/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 21 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* Version 1 */
void matrix_max_ver1 (int **mat, int r, int c) {
  int r1, r2, c1, c2, stop;

  for (r1=0; r1<r; r1++) {
    for (c1=0; c1<c; c1++) {
      stop = 0;
      for (r2=r1-1; r2<=r1+1 && !stop; r2++) {
        for (c2=c1-1; c2<=c1+1 && !stop; c2++) {
	  if ((r2!=r1 || c2!=c1) && r2>=0 && r2<r && c2>=0 && c2<=c &&
	      mat[r1][c1]<=mat[r2][c2]) {
	    stop = 1;
          }
        }
      }
      if (stop==0) {
        fprintf (stdout, "Local Max; row=%d column=%d\n", r1, c1);
      }
    }
  }

  return;
}

/* Version 2 */
void matrix_max_ver2 (int **mat, int r, int c) {
  int r1, r2, c1, c2, stop;

  for (r1=0; r1<r; r1++) {
    for (c1=0; c1<c; c1++) {
      stop = 0;
      for (r2=-1; r2<=1 && !stop; r2++) {
        for (c2=-1; c2<=1 && !stop; c2++) {
	  if (((r1+r2)!=r1 || (c1+c2)!=c1) && (r1+r2)>=0 &&
	      (r1+r2)<r && (c1+c2)>=0 && (c1+c2)<=c &&
	      mat[r1][c1]<=mat[r1+r2][c1+c2]) {
	    stop = 1;
          }
        }
      }
      if (stop==0) {
        fprintf (stdout, "Local Max; row=%d column=%d\n", r1, c1);
      }
    }
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
