/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 21 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define L 1000

int phrase_split (char v[], char ***m) {
  char **mat;
  int r, i, j, n, pos;

  // Count number of sub-strings
  r = 1;
  for (i=0; i<strlen(v); i++) {
    if (v[i]==' ') {
      r++;
    }
  }
  // Allocate main array of pointers
  mat = malloc (r * sizeof (char *));
  if (mat == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  pos = 0;

  // For each sub-string
  for (n=0; n<r; n++) {
    // Define sub-string limit
    for (i=pos; i<strlen(v); i++) {
      if (v[i]==' ') {
        break;
      }
    }
    // Allocate row
    mat[n] = malloc ((i-pos+1) * sizeof (char));
    if (mat[n] == NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
    // Copy chars from v to mat
    for (j=0, i=pos; i<strlen(v); j++, i++) {
      if (v[i]==' ') {
        break;
      }
      mat[n][j] = v[i];
    }
    mat[n][j] = '\0';
    pos = i+1;
  }
  
  *m = mat;

  return r;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
