/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 25 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

/* Version 1 */
void frame_sum_ver1 (int **mat, int n, int **vet) {
  int frame, i, *v;

  v = malloc (((int) (n/2) + 1) * sizeof (int));
  if (v==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit (EXIT_FAILURE);
  }

  for (frame=0; frame<(n/2); frame++) {
    v[frame] = 0;
    for (i=frame; i<(n-frame); i++) {
      v[frame] = v[frame] + mat[frame][i];
    }
    for (i=frame+1; i<(n-frame-1); i++) {
      v[frame] = v[frame] + mat[i][n-frame-1];
    }
    for (i=(n-frame-1); i>=frame; i--) {
      v[frame] = v[frame] + mat[n-frame-1][i];
    }
    for (i=(n-frame-2); i>=(frame+1); i--) {
      v[frame] = v[frame] + mat[i][frame]; 
   }
  }
  v[n/2] = mat[n/2][n/2];

  *vet = v;

  return;
}

/* Version 2 */
void frame_sum_ver2 (int **mat, int n, int **vet) {
  int frame, i, *v;

  v = malloc (((int) (n/2) + 1) * sizeof (int));
  if (v==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit (EXIT_FAILURE);
  }

  for (frame=0; frame<(n/2); frame++) {
    v[frame] = 0;

    for (i=frame; i<(n-frame); i++) {
      v[frame] = v[frame] + mat[frame][i] + mat[n-frame-1][i];
    }

    for (i=frame+1; i<(n-frame-1); i++) {
      v[frame] = v[frame] + mat[i][frame] + mat[i][n-frame-1];
    }
  }
  v[n/2] = mat[n/2][n/2];

  *vet = v;

  return;
}

/* Version 3 */
void frame_sum_ver3 (int **mat, int n, int **vet) {
  int frame, r, c, *v;

  v = malloc (((int) (n/2) + 1) * sizeof (int));
  if (v==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit (EXIT_FAILURE);
  }

  for (frame=0; frame<=(n/2); frame++) {
    v[frame] = 0;

    for (r=frame; r<(n-frame); r++) {
      for (c=frame; c<(n-frame); c++) {
        if (r==frame || r==(n-frame-1) || c==frame || c==(n-frame-1)) {
          v[frame] = v[frame] + mat[r][c];
        }
      }
    }
  }

  *vet = v;

  return;
}

/* Version 4 */
void frame_sum_ver4 (int **mat, int n, int **vet) {
  int r, c, i, *v;

  v = malloc (((int) (n/2) + 1) * sizeof (int));
  if (v==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit (EXIT_FAILURE);
  }
  for (i=0; i<((int) (n/2)); i++) {
    v[i] = 0;
  }

  for (r=0; r<n; r++) {
    for (c=0; c<n; c++) {
      if (r>c) {
        i = r;
      } else {
        i = c;
      }
      v[i] = v[i] + mat[r][c];
    }
  }

  *vet = v;

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
