/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 25 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

int **malloc2d (int, int);
int **free2d (int **, int);
static int matrix_check(int **, int *, int, int);

int matrix_swap (int **mat, int N, int *sol, int pos, int k, int start) {
  int i, n;

  n = N/2;
  if (pos >= k) {
    if (matrix_check(mat, sol, n, k)) {
      fprintf(stdout, "Solution: \n");
      for (i=0; i<k; i++) {
        if (sol[i] < n) {
          fprintf (stdout, "Row=%d ", sol[i]);
        } else {
          fprintf (stdout, "Column=%d ", sol[i]-n);
        }
      }
      fprintf (stdout, "\n");
      return 1;
    } else {
      return 0;
    }
  }

  for (i=start; i<N; i++) {
    sol[pos] = i;
    if (matrix_swap (mat, N, sol, pos+1, k, i+1)) {
      return 1;
    }
  }

  return 0;
}

static int matrix_check (int **mat, int *sol, int n, int k) {
  int i, j, ok, **flipMat;

  flipMat = malloc2d (n, n);
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      flipMat[i][j] = mat[i][j];
    }
  }

  for (i=0; i<k; i++) {
    if (sol[i] < n) {
      for (j=0; j<n; j++) {
        flipMat[sol[i]][j] = (flipMat[sol[i]][j]+1)%2;
      }
    } else {
      for (j=0; j<n; j++) {
        flipMat[j][sol[i]-n] = (flipMat[j][sol[i]-n]+1)%2;
      }
    }
  }

  ok = 1;
  for (i=0; i<n; i++) {
    for(j=0; j<n; j++) {
      ok &= flipMat[i][j];
    }
  }

  free2d (flipMat, n);

  return ok;
}



/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
