/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 26 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "graph.h"

struct graph_s {
  int **adj;
  int nv;
};

int graph_get_nv(graph_t g) {
  if (g != NULL)
    return g->nv;

  return -1;
}

graph_t graph_init (int nV) {
  graph_t g;
  int i;

  g = malloc (1 * sizeof (struct graph_s));
  if (g == NULL)
    return NULL;

  g->nv = nV;
  g->adj = calloc (nV, sizeof (int*));
  if (g->adj == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  
  for (i=0; i<nV; i++) {
    g->adj[i] = calloc(nV, sizeof(int));
    if (g->adj[i] == NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
  }
  
  return g;
}

void graph_insert_edge (graph_t g, int src, int dst) {
  if (src < 0 || dst < 0)
    return;
  if (g->adj == NULL)
    return;
  g->adj[src][dst] = g->adj[dst][src] = 1;

  return;
}

int graph_check_adjancency (graph_t g, int x, int y) {
  if (g == NULL || g->adj == NULL)
    return 0;
  
  return (g->adj[x][y] != 0);
}

int graph_get_weight (graph_t g, int x, int y) {
  if (g == NULL || g->adj == NULL)
    return 0;
  
  return (g->adj[x][y]);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
