/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 26 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "list.h"

typedef struct node_s {
  int index;
  struct node_s *next;
} node_t;

struct list_s {
  node_t *head;
  node_t *tail;
};

static node_t *node_create (int, node_t *);
  
list_t list_init () {
  list_t list;

  list = calloc (1, sizeof (struct list_s));
  if (list == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    return NULL;
  }
  list->head = list->tail = NULL;

  return list;
}

void list_insert (list_t list, int value) {
  node_t *node;

  if (list == NULL) {
    return;
  }
  node = node_create (value, NULL);
  if (list->head == NULL) {
    list->head = list->tail = node;
    return;
   }
  list->tail->next = node;
  list->tail = node;

  return;
}

void list_write (list_t list, st_t st) {
  node_t *tmp;

  if (list == NULL) {
    return;
  }
  for (tmp=list->head; tmp!=NULL; tmp=tmp->next) {
    fprintf (stdout, "%s ", st_read (st, tmp->index));
  }
  fprintf (stdout, "\n");

  return;
}

static node_t *node_create (int index, node_t *next) {
  node_t *node;

  node = calloc (1, sizeof (node_t));
  if (node == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    return NULL;
  }
  node->index = index;
  node->next = next;

  return node;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
