/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 29 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

static void powerset (int **, int, int, int, int *, int);
static int powerset_r (int **, int, int, int, int *, int, int, int, int);

void balance (int **mat, int r, int c, int k) {
  int *solution, nel;

  nel = r * c;
  solution = malloc (nel * sizeof (int));
  if (solution==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  
  powerset (mat, r, c, k, solution, nel);

  free (solution);
  
  return;
}

/*
 *  Powerset
 */
static void powerset (
  int **mat, int r, int c, int k, int *solution, int nel
  )
{
  int i, j;

  fprintf (stdout, "Smallest cardinality set: ");
  for (i=1; i<=nel; i++) {
    if (powerset_r (mat, r, c, k, solution, nel, i, 0, 0)==1) {
      break;
    }
  }
  fprintf (stdout, "Largest cardinality set: ");
  for (j=nel; j>i; j--) {
    if (powerset_r (mat, r, c, k, solution, nel, j, 0, 0)==1) {
      break;
    }
  }

  return;
}

static int powerset_r (
  int **mat, int r, int c, int k,
  int *solution, int nel, int n, int pos, int start
  )
{
  int i, ri, ci, sum;

  /* Check condition */
  if (pos == n) {
    sum = 0;
    for (i=0; i<n; i++) {
      /* From i (solution index) to ri and ci (mat indices) */
      ri = (int) (solution[i] / c);
      ci = (int) (solution[i] % c);
      sum = sum + mat[ri][ci];
    }
    if (sum==k) {
      fprintf (stdout, "n=%d { ", n);
      for (i=0; i<n; i++) {
        ri = (int) (solution[i] / c);
        ci = (int) (solution[i] % c);
        fprintf (stdout, "[%d,%d]%d ", ri, ci, mat[ri][ci]);
      }
      fprintf (stdout, "}");
      fprintf (stdout, " sum=%d\n", sum);
      return 1;
    } else {
      return 0;
    }
  }

  for (i=start; i<nel; i++) {
    solution[pos] = i;
    if (powerset_r (mat, r, c, k, solution, nel, n, pos+1, i+1)==1) {
      return 1;
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
